/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.services;

import cz.cvut.kbss.bodm.nativequery.Employee;
import cz.cvut.kbss.dao.GenericDAOImpl;
import cz.cvut.kbss.pdto.EmployeeDTO;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 *
 * @author user
 */
public class EmployeeService {

    private static EmployeeService employeeService;

    public static EmployeeService getEmployeeService(){
        if(employeeService == null){
            employeeService = new EmployeeService();
        }
        return employeeService;
    }
    
    
    private EmployeeService() {
    }
    
    public List<EmployeeDTO> getEmployees(){
        Collection<Employee> employees = GenericDAOImpl.getGenericDAO().getAll(Employee.class);
        List<EmployeeDTO> edtos = new ArrayList<EmployeeDTO>(employees.size());
        for(Employee e : employees){
            EmployeeDTO edto = new EmployeeDTO(e.getId(), e.getName(), e.getSurname());
            edtos.add(edto);
        }
        return edtos;
    }
    
    public EmployeeDTO saveEmployee(EmployeeDTO dto){
        Employee emp = new Employee(dto);
        Employee saved = GenericDAOImpl.getGenericDAO().saveOrUpdate(emp);
        
        EmployeeDTO saveddto = new EmployeeDTO(saved.getId(),saved.getName(),saved.getSurname());
        return saveddto;
    }
    
    
}
