/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.bodm.manytooneonetomany;

import cz.cvut.kbss.dao.GenericDAOIface;
import cz.cvut.kbss.dao.GenericDAOImpl;
import java.util.List;

/**
% *
 * @author user
 */
public class TestManyToOneOneToManyRelations {
    public static void main(String[] args) {
        GenericDAOIface dao = GenericDAOImpl.getGenericDAO();
        
        List<DocumentEntity> docs = dao.getAll(DocumentEntity.class);
        System.out.println(docs.size());
        
        // test save entity with both keys null
        DocumentEntity de = new DocumentEntity();
        de = dao.saveEntity(de);
        DocumentRevision dr = new DocumentRevision();
        dr.setDocument(de);
        dr.setDocumentText("This is the document text of a new document. And here is some more text.");
        dr = dao.saveEntity(dr);
        DocumentRevision newdr = new DocumentRevision();
        newdr.setDocument(de);
        newdr.setDocumentText(dr.getDocumentText() + " This is a newer revision of the document.");
        newdr = dao.saveEntity(newdr);
        
        printRevisions(dao.getAll(DocumentEntity.class));
        // test save entity with one key set and the other null
        // Creating a new rrevision
        // note : this code cannot be used on client side because the if the entity 
        // is managed (in this case is not but still it is not a good practice)
        // the not null exepctinon will be thrown because of the not 
        // null constraint of the id
//        DocumentEntity newde = new DocumentEntity();
//        newde.setId(de.getId());
//        newde.setDocumentText(de.getDocumentText() + " This is a change in the document in a newer  revision.");
//        newde = dao.saveEntity(newde);
        
    }
    
    public static void printRevisions(List<DocumentEntity> docs){
        for(DocumentEntity de : docs){
            printRevision(de);
        }
    }
    
    public static void printRevision(DocumentEntity doc){
        System.out.println("Document id = " + doc.getId());
        for(DocumentRevision dr : doc.getRevisions()){
            System.out.println("\trevision id = " + dr.getId());
            System.out.println("\tDocument content = " + dr.getDocumentText());
        }
    }
}
