/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.bodm.nativequery;

import cz.cvut.kbss.bodm.DomainEntity;
import cz.cvut.kbss.pdto.EmployeeDTO;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 *
 * @author user
 */
@Entity
@Table(name="employee")
public class Employee extends DomainEntity{
    
    protected String name;
    protected String surname;

    public Employee() {
    }

    public Employee(Long id, String name, String surname) {
        this.id = id;
        this.name = name;
        this.surname = surname;
    }
    
    public Employee(EmployeeDTO emp){
        this(emp.getId(), emp.getName(), emp.getSurname());
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSurname() {
        return surname;
    }

    public void setSurname(String surname) {
        this.surname = surname;
    }
    
    
}
