/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.bodm.nativequery;

import cz.cvut.kbss.jpautils.JPAUtility;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.Query;

/**
 *
 * @author user
 */
public class TestNativeQueryReturningEntity {
    public static void main(String[] args) {
        testNativeQueryWithoutType();
        testNativeQueryWithEntityType();
    }
    
    public static void testNativeQueryWithEntityType(){
        EntityManager em = JPAUtility.createNewEntityManager();
        Query query = em.createNativeQuery("select * from employee", Employee.class);
        List<Employee> employees = query.getResultList();
        for(Employee e : employees){
            System.out.println(e.getId() + ", " + e.getName() + ", " + e.getSurname());
        }
    }
    
    public static void testNativeQueryWithoutType(){
        EntityManager em = JPAUtility.createNewEntityManager();
        Query query = em.createNativeQuery("select * from employee");
        List<Object[]> employees = query.getResultList();
        
        for(Object[] e : employees){
            for(Object col : e){
                System.out.print(col + ", ");
            }
            System.out.println("");
        }
    }
}
