/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.dao;

import cz.cvut.kbss.bodm.DomainEntity;
import java.util.List;

/**
 * priklad jednoduheho generickych interface DAO 
 * @author user
 */
public interface GenericDAOIface {
    public <ENTITY> List<ENTITY> getAll(Class<ENTITY> clazz);
    public <ENTITY extends DomainEntity> ENTITY saveOrUpdate(ENTITY inst);
    public <ENTITY> ENTITY saveEntity(ENTITY entity);
    
    public <ENTITY> ENTITY mergeEntity(ENTITY entity);
    
    public <ENTITY> void removeAll(Class<ENTITY> clazz);
    public <ENTITY> ENTITY findBy(Class<ENTITY> clazz, String attrName, String attrVal);
}
