/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.jpautils;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 *
 * @author user
 */
public class JPAUtility {
    
    private static EntityManagerFactory factory;
    
    /**
     * Jednoducha implementace navrhoveho vzoru singelton pro zaruceni jedinecne 
     * instance EntityManagerFactory.
     * @return 
     */
    public static EntityManagerFactory getFactory(){
        if(factory == null){
            factory = Persistence.createEntityManagerFactory("sample_persistence_unit");
        }
        return factory;
    }

    
    /**
     * factory metoda pro vytvareni instance EntityManager.
     * @return 
     */
    public static EntityManager createNewEntityManager(){
        return getFactory().createEntityManager();
    }
    
}
